#!/bin/sh
# Sign framework
if [ "$SDL_CODESIGN_IDENTITY" != "" ]; then
    codesign --force --deep --sign "$SDL_CODESIGN_IDENTITY" $TARGET_BUILD_DIR/SDL2.framework/Versions/A
fi

# clean up the framework, remove headers, extra files
mkdir -p build/dmg-tmp
xcrun CpMac -r $TARGET_BUILD_DIR/SDL2.framework build/dmg-tmp/

cp pkg-support/resources/License.txt build/dmg-tmp
cp pkg-support/resources/ReadMe.txt build/dmg-tmp

# remove the .DS_Store files if any (we may want to provide one in the future for fancy .dmgs)
find build/dmg-tmp -name .DS_Store -exec rm -f "{}" \;

# for fancy .dmg
mkdir -p build/dmg-tmp/.logo
cp pkg-support/resources/SDL_DS_Store build/dmg-tmp/.DS_Store
cp pkg-support/sdl_logo.pdf build/dmg-tmp/.logo

# create the dmg
hdiutil create -ov -fs HFS+ -volname SDL2 -srcfolder build/dmg-tmp build/SDL2.dmg

# clean up
rm -rf build/dmg-tmp
