#include<stdio.h>
#include<glsc3d_3.h>

int main()
{
    int INTV = 100;
	g_init("Window", 600, 600);					//Pixel Size
	g_def_scale_2D(0,							//ID
				   -1, 1,						//xmin,xmax
				   -1, 1,						//ymin,ymax
				   20.0, 20.0,					//Window (Left, Top) Position
				   560, 560);					//Window Size (x,y)

    //////////// Start time loop ////////////
    for (int i_time = 0; ; i_time++) {
        double dt = 0.0001;						//Time Discritization
        double t = i_time * dt;					//Time
        //////////// Calculation Part ////////////
        double x = 0.5 * cos(2.0*M_PI * t);     //X Coordinate
        double y = 0.5 * sin(2.0*M_PI * t);     //Y Coordinate
        //////////// Draw Part ////////////
        if (i_time%INTV == 0) {
            g_cls();							//Clear window
            g_sel_scale(0);						//Select Virtual scale
            g_boundary();						//Draw Boundary
            g_area_color(1,0,0,1);              //Area Color
            g_circle_2D(x, y, 0.1, G_NO, G_YES);//g_circle_2D
            g_finish();							//flush Draw buffer
            g_sleep(0.01);						//Sleep 0.01 sec
        }
    }
	return 0;
}
